//******************************************************************************
//*****    STRUCTURES STOCKANT LES INFORMATIONS RELATIVES AUX MATERIELS   ******
//******************************************************************************

  //Constantes
  maxMat  = 450;// Nombre maximal de matriel
  maxCara = 10;//Nombre maximal de proprits d'un matriel
  maxFace = 8 ;// Nombre maximal de face  afficher ( nombre de photos par matriel )
  titre = 0;//Indice pour le titre d'une la caractristique
  valeur = 1;//Indice pour la valeur d'une la caractristique

  //Tableau des titres des matriels
  titreMat = new Array(maxMat);
  
  //Tableau des commentaires sur les matriels
  texteMat = new Array(maxMat);

  //Matrice des caractristiques des matriels
  descrMat = new Array(maxMat);
  for (i=0;i<maxMat;i++){
    descrMat[i] = new Array(maxCara);
    for (j=0;j<maxCara;j++){
      descrMat[i][j] = new Array(2);
    }
  }


  //Matrice stockant les matriels et leurs photos
  photoMat = new Array(maxMat);
  for (i=0;i<maxMat;i++){
      photoMat[i] = new Array(maxFace);
  }


  numMatCour  = -1;//Matriel courant
  numFaceCour = 0;//Face courante
  nbEssaiFace = 0;//Gestion d'erreur en cas de photo non renseigne
  nbEssaiMat = 0;//Gestion d'erreur en cas de photo non renseigne


    

//******************************************************************************
//*****    FONCTIONS ET PROCEDURES POUR ACCEDER AUX                       ******
//*****    STRUCTURES STOCKANT LES INFORMATIONS RELATIVES AUX MATERIELS   ******
//******************************************************************************


  function calculerFace(){
	  if (numFaceCour >= maxFace )
       numFaceCour = 0;	
    else if (numFaceCour < 0  )
            numFaceCour =  maxFace-1
  }
  
  
 	//----------------------------------------
  // Change de vue pour le matriel courant
 	//----------------------------------------
	function changerVue( vue ){
		nbEssaiFace = 1;

	  numFaceCour = numFaceCour + vue;
    	  calculerFace();

  	//On change de vue s'il n'y a pas de photos pour la vue demande
  	if ( photoMat[numMatCour][numFaceCour] == null ){

  	   while( photoMat[numMatCour][numFaceCour] == null && nbEssaiFace < maxFace ){
    	   	nbEssaiFace++;
    	   	numFaceCour = numFaceCour + vue;
         	calculerFace();
  	   }

    	 if ( photoMat[numMatCour][numFaceCour] == null ){
      	  	document.visite.foto.src = "\#";
            	document.visite.foto.alt='Pas d\'image pour ce matriel';
	}
       else{
         	document.visite.foto.src = photoMat[numMatCour][numFaceCour];
   	      document.visite.foto.alt=" ";
      	}
  	}
      else{
      source = photoMat[numMatCour][numFaceCour];
         	document.visite.foto.src = photoMat[numMatCour][numFaceCour];
         	document.visite.foto.alt=" ";
      }
     }



  function calculerMat(){
	  if (numMatCour >= maxMat )
       numMatCour = 0;	
    else if (numMatCour < 0  )
            numMatCour =  maxMat-1
  }
  
 	//---------------------------------------------
  //Change de matriel et affiche la vue de face
 	//---------------------------------------------
	function changerMat(sens){

	  nbEssaiMat = 1;	
	  numMatCour = numMatCour + sens;
    calculerMat();
    
    while(titreMat[numMatCour] == null &&  nbEssaiMat < maxMat ){
       nbEssaiMat++;
       numMatCour = numMatCour + sens;
       calculerMat();
    }

    
    if(titreMat[numMatCour] == null ){
        document.visite.titre.clear;
        document.visite.commentaires.clear;
        document.visite.foto.alt='Pas d\'image de matriel  afficher';
    }else{
          modifierTextes(numMatCour);
          numFaceCour = -1;
          changerVue(1);
        }
    
	}


  //-------------------------------------------------------------------
  // Met  jour les zones de textes affichant les informations sur le matriel
  //-------------------------------------------------------------------
  function  modifierTextes(numeMatCour){
    var texteZone ="";
    
    document.visite.titre.clear;
    document.visite.titre.value = titreMat[numeMatCour];
    
    i=0;
    while ( descrMat[numeMatCour][i][titre] != null && i< maxCara ){
       texteZone = texteZone + descrMat[numeMatCour][i][titre]+" : " + descrMat[numeMatCour][i][valeur];
       texteZone = texteZone + '\n';
       i++;
    }
      texteZone = texteZone + '\n\n' + texteMat[numeMatCour];
      
    document.visite.commentaires.clear;
    document.visite.commentaires.value = texteZone ;
  }


  //-------------------------------------------------------------------
  // Insere l'image servant  afficher l'objet sous toute ses facettes
 	//-------------------------------------------------------------------
  function insererVisite(){
    var cols;//Largeur de la zone de texte. Elle est diffrente suivant les navigateurs...
     if (navigator.appName!="Microsoft Internet Explorer"){
     	  if (navigator.appName=="Konqueror"){
    		  cols = 55;
      	}else{
         		if (navigator.platform == "Win32"){//Netscape sous windows
          			cols = 40;
          	}else{//Sous linux et autre ... : Netscape, Mozilla, Galeon ...
          	   cols = 65;
           	 }
         }
    }else{//Internet Explorer
      cols =55;
    }
  
    document.write('<form name=visite>');
    document.write('<table align="center" size="80%" >');
    document.write('  <tr>');
    document.write('        <td>');
    document.write('            <img name="foto" src="+photoMat[numFaceCour][numMatCour]+" height="300" width="500"   />');
    document.write('        </td>');
    document.write('        <td>');
    document.write('        <textarea name="titre" ROWS="1"  COLS="'+cols+'" ALIGN=center READONLY >');
    document.write('        </textarea>');
    document.write('            <textarea name="commentaires" ROWS="17"  COLS="'+cols+'" WRAP READONLY >');
    document.write('            </textarea>');
    document.write('        </td>');
    document.write('  </tr>');
    document.write('</table>');
    document.write('<table align="center" size="80%" >');
    document.write('  <a href="anchor" name="foto"></a>');
    document.write('  <tr>');
    document.write('    <td>');
    document.write('      <a href="#foto" onclick="changerMat(-1);"><img src="vv/precedente.gif" height=30 /></a>');
    document.write('    </td>');
    document.write('    <td>');
    document.write('      <a href="#foto" onclick="changerVue(-1);"><img src="vv/rotation_gauche.gif" height=30 /></a>');
    document.write('    </td>');
    document.write('    <td>');
    document.write('      <a href="#foto" onclick="changerVue(1);"><img src="vv/rotation_droite.gif" height=30 /></a>');
    document.write('    </td>');
    document.write('    <td>');
    document.write('      <a href="#foto" onclick="changerMat(1);"><img src="vv/suivante.gif" height=30 /></a>');
    document.write('    </td>');
    document.write('  </tr>');
    document.write('</table>');
    document.write('  </form>');

    changerMat(1);
  }
  
  


  //-------------------------------------------------------------------
  // Ecrit les caractristiques d'un matriel
  //-------------------------------------------------------------------
  function insererCaraMat(numMatCour){
      var texteZone ="<table align=center width=60%>";
      var i = 0;

      while ( descrMat[numMatCour][i][titre] != null && i< maxCara ){
         texteZone = texteZone +
                     "<tr><td>" +
                     descrMat[numMatCour][i][titre]  + " : </td><td>" +
                     descrMat[numMatCour][i][valeur] + "</td></tr>";
         i++;
      }
      texteZone = texteZone + '<table>';
      document.write(texteZone);
  }


  //-------------------------------------------------------------------
  // Ecrit les commentaires sur un matriel
  //-------------------------------------------------------------------
  function insererCommentaireMat(numMatCour){
    document.write("<table align=center width=60%>");
    document.write("	<tr>");
    document.write("		<td>");
    document.write(texteMat[numMatCour]);
    document.write("		</td>");
    document.write("	</tr>");
    document.write("</table>");
  }



  //-------------------------------------------------------------------
  // Gnre la page d'affichage des matriels
  //-------------------------------------------------------------------
  function genererPageMat(){
      var i=0;
      while ( titreMat[i] != null && i< maxMat ){
        insererTitre(titreMat[i],"");
        insererImage(photoMat[i][0],"","");
        insererCaraMat(i);

        insererCommentaireMat(i);
        i++;
    }
  }


  //-------------------------------------------------------------------
  // Affiche la zone correspondante au mode d'affichage demand
  //-------------------------------------------------------------------
  function show(zone){
    if ( zone == 1 ){
    	zoneListe.style.display="";
    	zoneVisite.style.display="none";
    }
    else{
    	zoneVisite.style.display="";
    	zoneListe.style.display="none";
    }
  }

  //-------------------------------------------------------------------
  // Ajoute un titre de matriel dans la "base"
  //-------------------------------------------------------------------
  function ajouterTitre(titre){
    titreMat[++numMatCour] = titre;
    numCarCour = 0;
    numFaceCour = -1;
  }

  //-------------------------------------------------------------------
  // Ajoute un commentaire pour le materiel courant.
  //-------------------------------------------------------------------
  function ajouterComm(comm){
  	texteMat[numMatCour] = comm;
  }

  //-------------------------------------------------------------------
  // Ajoute un caractre pour le matriel courant.
  // Si le nombre de caratre est atteint, il n'est pas ajout.
  //-------------------------------------------------------------------
  function ajouterCara(cara,vale){  
	 if ( numCarCour < maxCara -1 ) {
	   descrMat[numMatCour][numCarCour][titre]=cara;
	   descrMat[numMatCour][numCarCour++][valeur]=vale;
	 }
  }
  
  //-------------------------------------------------------------------
  // Initialise la photo pour l'objet en cours
  //-------------------------------------------------------------------
  function photo(face,foto){
  	photoMat[numMatCour][face]=foto;
  }
