//******************************************************************************
//**************    GESTION DE LA VISITE DU MUSEE VIRTUEL   ********************
//******************************************************************************
//******************************************************************************
    /* Schma des diffrentes vues d'un materiel
      3 4 5            0 - Face                5 - 3/4 arrire droit
       \|/             1 - 3/4 avant gauche    6 - Ct gauche
     2 -M- 6           2 - Ct gauche         7 - 3/4 avant droit
       /|\             3 - 3/4 arrire gauche
      1 0 7            4 - Arrire
    */
//******************************************************************************

  
  //= DEBUT MATERIEL ===========================================
  //***************  Socit francaise Vierzon 201
  //------------------------------------------------------------
  ajouterTitre("Socit Franaise Vierzon  -  201");
  ajouterCara("Anne","1955 env.");
  ajouterCara("Moteur","Mono cylindre  plat,Boule chaude");
  ajouterCara("Puissance","18 - 20 cv");
  ajouterCara("nergie","Semi-diesel");
  ajouterCara("Mise en route","Dmarrage par volant");
  ajouterCara("Pays d'origine","France");
  ajouterComm("Ce tracteur a t rnov de juillet 2003 jusqu' juin 2004. "+
              "Il a t prsent  la fte locale des vielles mcaniques.");
  photo(0,"201/201_face.gif");
  photo(1,null);
  photo(2,"201/201_prg.gif");
  photo(3,null);
  photo(4,"201/201_arriere.gif");
  photo(5,null);
  photo(6,null);
  photo(7,"201/201_prd.gif");
  //= FIN MATERIEL =============================================


  //= DEBUT MATERIEL  ==========================================
  //***************** MINITRAC
  //------------------------------------------------------------
  // TITRE
  ajouterTitre("Minitrac");
  ajouterCara("Anne","1958");
  ajouterCara("Dmarrage","lectrique");
  ajouterCara("Moteur","Peugeot 203");
  ajouterCara("Puissance","18 - 20 cv");
  ajouterCara("nergie","essence");
  ajouterCara("Pays d'origine","France");
  ajouterComm("Ce tracteur va bientt tre remis sur pied un minitrac. "+
              "Or nous ne possdons aucune documentation sur tracteur. "+
              "Si vous pouvez nous en procurer, n'hsitez pas  crire  "+
              "gaetan.pineau@cegetel.net "+
              "Le minitrac est un tracteur qui a t construit  Angers dans le Maine et "+
              " Loire. C'est un petit tracteur qui ressemble  un buldozer." );
  photo(0,"minitrac/minitrac_face.gif");
  photo(1,null);
  photo(2,"minitrac/minitrac_prg.gif");
  photo(3,null);
  photo(4,"minitrac/minitrac_arriere.gif");
  photo(5,null);
  photo(6,null);
  photo(7,"minitrac/minitrac_prd.gif");
  //= FIN MATERIEL  ==========================================

  //= DEBUT MATERIEL  ==========================================
  //***************** SIFT H35
  //------------------------------------------------------------
  // TITRE
  ajouterTitre("SIFT  -  H35");
  ajouterCara("Anne","1955 env.");
  ajouterCara("Dmarrage","");
  ajouterCara("Moteur","");
  ajouterCara("Puissance","");
  ajouterCara("nergie","");
  ajouterCara("Pays d'origine","France");
  ajouterComm(" Ce tracteur a travers toute la France, car il a t retrouv dans une ferme" +
              " de l'est de la France.Coup de coeur pour ce tracteur dont des exemplaires " +
              " similaires  ce modle ont t vendus dans le garage de la commune dans les annes 50.");
  photo(0,null);
  photo(1,null);
  photo(2,null);
  photo(3,null);
  photo(4,null);
  photo(5,null);
  photo(6,null);
  photo(7,null);
  //= FIN MATERIEL  ==========================================


  //= DEBUT MATERIEL  ==========================================
  //***************** D22
  //------------------------------------------------------------
  // TITRE
  ajouterTitre("Renault D22");
  ajouterCara("Anne","1960 env.");
  ajouterCara("Dmarrage","");
  ajouterCara("Moteur","");
  ajouterCara("Puissance","");
  ajouterCara("nergie","");
  ajouterCara("Pays d'origine","France");
  ajouterComm(" Tracteur de mon grand-pre");
  photo(0,null);
  photo(1,null);
  photo(2,null);
  photo(3,null);
  photo(4,null);
  photo(5,null);
  photo(6,null);
  photo(7,null);
  //= FIN MATERIEL  ==========================================



//******************************************************************************
    /* Schma des diffrentes vues d'un materiel
      3 4 5     8       0 - Face                5 - 3/4 arrire droit
       \|/      (       1 - 3/4 avant gauche    6 - Ct gauche
     2 -M- 6    M       2 - Ct gauche         7 - 3/4 avant droit
       /|\      )       3 - 3/4 arrire gauche  8 - Dessus
      1 0 7     9       4 - Arrire             9 - Dessous
    */
//******************************************************************************
  numMatCour = -1;
  numFaceCour = 0;
